/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


package actions;

import java.awt.event.ActionEvent;
import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.KeyStroke;

import dialogs.AffichageObjetsNumeriquesDlg;

import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class ActionAfficherObjetsNumeriques extends MtgAction {
	
	public ActionAfficherObjetsNumeriques(MtgFrame frameInit) {
		super(frameInit, null, getString("chaineMenuAfficherObjetsNumeriques"),
				getString("chaineTipAfficherObjetsNumeriques"), iconeAssociee(), KeyStroke.getKeyStroke("F6"));
	}
	
	@Override // Ajout version 4.3
  public boolean estDansBarreHorizontale() {
  	return true;
  }	

	@Override
	public void actionPerformed(ActionEvent e) {
		super.actionPerformed(e);
		AffichageObjetsNumeriquesDlg dlg = new AffichageObjetsNumeriquesDlg(frame);
		dlg.setLocationRelativeTo(frame);
		dlg.setVisible(true);
	}
	
	// Ajout version 4.3 pour que l'outil puisse tre activ ou non
  @Override
  public int idMenu() {
    return 32023;
  }
	
  public static ImageIcon iconeAssociee() {
    URL adr = MtgFrame.class.getResource("images/VoirCalculs.png");
    return new ImageIcon(adr);    
  }
	

}
