/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class FigureParCodeDlg extends MtgDlg {
	private JLabel label1;
	private JTextArea editeurCode;
	private JScrollPane scrollPaneAffichage;
	private JButton btnOK, btnCancel;
	public String code;
	
  public FigureParCodeDlg(MtgFrame frameInit) {
    super(getString("figureParCodeDlg1"), true, frameInit);
    initComponents();
    getRootPane().setDefaultButton(btnOK);
    editeurCode.requestFocus();
  }
  
  private void initComponents() {
  	label1 = new JLabel(getString("figureParCodeDlg2"));
  	editeurCode = new JTextArea();
  	editeurCode.setLineWrap(true);
		// editeurTexte.setFont(FonteNom.getFonteNom(2, FonteNom.Normal, -1)); // Supprim version 4.7.5.2 pris en charge augmentation polices systme   
 		editeurCode.setRows(18);
 		editeurCode.setColumns(55);
    scrollPaneAffichage = new JScrollPane
  		(editeurCode, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    btnOK = new javax.swing.JButton(getString("btnOK")); 
    btnOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        btnOKActionPerformed();
      }
    });    
    btnCancel = new javax.swing.JButton(getString("btnCancel"));
    btnCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        btnCancelActionPerformed();
      }
    });
    btnOK.setMaximumSize(btnCancel.getPreferredSize());  	
  	
    JPanel pane = new JPanel();
    pane.setLayout(new GridBagLayout());
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.top = 4;
    constraints.insets.bottom = 4;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    
    setConstraints(constraints, 0, 0, 1, 1, 80, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    pane.add(label1, constraints);
    setConstraints(constraints, 0, 1, 1, 1, 0, 90, GridBagConstraints.NONE, GridBagConstraints.WEST);
    pane.add(scrollPaneAffichage, constraints);
    
    JPanel paneRight = new JPanel();
    paneRight.setLayout(new BoxLayout(paneRight, BoxLayout.Y_AXIS));
    paneRight.add(btnOK);
    paneRight.add(btnCancel);
    setConstraints(constraints, 2, 0, 1, 4, 20, 50, GridBagConstraints.NONE, GridBagConstraints.NORTHEAST);
    pane.add(paneRight, constraints);
    setContentPane(pane);
    pack();
  }
  
  private void btnOKActionPerformed() {
  	setRetourOK(true);
  	code = editeurCode.getText();
  	dispose();
  }

  private void btnCancelActionPerformed() {
  	dispose();
  }
}
