/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JTextArea;
import javax.swing.JTextField;



/**
 * Reprsente un type de bouton contenant un caractre.
 * Ce bouton est associ  un JTextField.
 * Quand on cliquera sur le bouton le caractre sera insr dans le JTextfield au point d'insertion actif.
 * @author Yves
 *
 */
@SuppressWarnings("serial")
public class MtgCharButton extends JButton implements ActionListener {
	private PaneInsertionCaractere paneAssocie;
	private int code;
  private static Insets insets = new Insets(2,2,2,2);
  private static final JButton refButton = new JButton("M");
	/**
	 * Constructeur par le code unicode du caractre
	 * @param code
	 */
	public MtgCharButton(int codeInit, PaneInsertionCaractere paneAssocieInit) {
		super(new String (Character.toString((char) codeInit)));
		setMaximumSize(refButton.getPreferredSize());
		code = codeInit;
		paneAssocie = paneAssocieInit;
    setMargin(insets);
  	setFocusable(false); // Important pour viter que le dialogue de caractres spciaux soit raffich
  	//  chaque fois qu'on presse le bouton
		addActionListener(this);
		setFocusPainted(false);
	}

	public void actionPerformed(ActionEvent e) {
		if (paneAssocie.editeurAssocie.getClass() == TextFieldAvecCarSpeciaux.class) {
			JTextField editeurAssocie = (JTextField) paneAssocie.editeurAssocie;
	    int i = editeurAssocie.getCaretPosition();
	    String ch = editeurAssocie.getText();
	    String ch2 = ch.substring(0, i) + Character.toString((char) code) + ch.substring(i);
	    editeurAssocie.setText(ch2);
	    editeurAssocie.requestFocus();
	    editeurAssocie.setCaretPosition(i+1);
	    // On informa la fentre propruitaire qu'elle doit si ncessaire remettre  jour
	    //l'affichage clignotant (pour CommentaireDlg et LatexDlg)
	    MtgDlg owner = (MtgDlg) (editeurAssocie.getTopLevelAncestor());
	    owner.metAJourAffichageClignotant();
		}
		else {
			if (paneAssocie.editeurAssocie.getClass() == TextAreaAvecCarSpeciaux.class) {
				JTextArea editeurAssocie = (JTextArea) paneAssocie.editeurAssocie;
		    int i = editeurAssocie.getCaretPosition();
		    String ch = editeurAssocie.getText();
		    String ch2 = ch.substring(0, i) + Character.toString((char) code) + ch.substring(i);
		    editeurAssocie.setText(ch2);
		    editeurAssocie.requestFocus();
		    editeurAssocie.setCaretPosition(i+1);
		    // On informa la fentre propruitaire qu'elle doit si ncessaire remettre  jour
		    //l'affichage clignotant (pour CommentaireDlg et LatexDlg)
		    MtgDlg owner = (MtgDlg) (editeurAssocie.getTopLevelAncestor());
		    owner.metAJourAffichageClignotant();
			}
			
		}
	}

}
