/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JLabel;
import javax.swing.JScrollPane;

import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class PaneOptionsFigureMacroParDefaut extends PaneOptionsFigure {
	private JLabel label1;
	private ListeMacrosAnimation listeMacros;
	private JScrollPane scrollPane;
	
	public PaneOptionsFigureMacroParDefaut(MtgInternalFrame cadreInit) {
    super(cadreInit);
    initComponents();
	}
	
	public void initComponents() {	
		label1 = new JLabel(MtgDlg.getString("macroParDefaut"));
		listeMacros = new ListeMacrosAnimation(cadre.listePr);
		scrollPane = new JScrollPane(listeMacros, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    setLayout(new GridBagLayout());

		GridBagConstraints constraints = new GridBagConstraints();
		constraints.insets.bottom = 5;
		constraints.insets.top = 5;
		constraints.insets.left = 5;
		constraints.insets.right = 5;

		MtgDlg.setConstraints(constraints, 0, 0, 1, 1, 100, 20, GridBagConstraints.NONE, GridBagConstraints.WEST);
		add(label1, constraints);
		MtgDlg.setConstraints(constraints, 0, 1, 1, 1, 0, 80, GridBagConstraints.BOTH, GridBagConstraints.WEST);
		add(scrollPane, constraints);
	}
	
  public boolean sauveDonnees() {
  	cadre.listePr.macroParDefaut = listeMacros.macroChoisie();
  	return false; // False car mme en cas de changement la figure n'a pas  tre actualise
  }
	
	public String titreOnglet() {
		return MtgDlg.getString("ongletMacroParDefaut");
	}	

}
