/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package mathgraph32;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.net.URL;
import java.util.Vector;

import javax.swing.ImageIcon;
import javax.swing.JList;
import javax.swing.ListSelectionModel;

@SuppressWarnings("serial")
public class MtgListeStyleRemplissage extends JList<ImageIcon> implements MouseListener {
	private MtgFrame frame;

  public MtgListeStyleRemplissage(MtgFrame frameInit) {
    super();
    frame = frameInit;
    setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    setLayoutOrientation(JList.VERTICAL);
    setVisibleRowCount(4);
    Vector<ImageIcon> vec = new Vector<ImageIcon>();
    URL adr = MtgFrame.class.getResource("images/StyleHachureTransp.gif");
    ImageIcon icon = new ImageIcon(adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/StyleHachurePlein.gif");
    icon = new ImageIcon(adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/StyleHachure45Bas.gif");
    icon = new ImageIcon(adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/StyleHachure45Haut.gif");
    icon = new ImageIcon(adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/StyleHachureHor.gif");
    icon = new ImageIcon(adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/StyleHachureVer.gif");
    icon = new ImageIcon(adr);
    vec.add(icon);
    setListData(vec);
    setSelectedIndex(0);
    setToolTipText(MtgFrame.getString("tipChoixStyleHachure"));
    addMouseListener(this);
  }

  public int styleRemplissage() {
    return 5 - getSelectedIndex();
  }
  
	public void mouseClicked(MouseEvent arg0) {
	}

	public void mouseEntered(MouseEvent arg0) {
    if (getCursor() != MtgFrame.defaultCursor) frame.setCursor(MtgFrame.defaultCursor);
	}

	public void mouseExited(MouseEvent arg0) {
	}

	public void mousePressed(MouseEvent arg0) {
	}

	public void mouseReleased(MouseEvent arg0) {
	}

}
