/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package mathgraph32;

import java.awt.Insets;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JPanel;
import javax.swing.JToolBar;

import types.StyleFleche;

@SuppressWarnings("serial")
public class MtgPaneStyleFleche extends JPanel implements MouseListener {
	private MtgFrame frame;
	private static Insets ins = new Insets(0, 0, 0, 0);
	
  public MtgPaneStyleFleche(MtgFrame frameInit) {
    super();
    frame = frameInit;
  	// Les deux barres d'outils horizontales servant  contenir les icnes de
  	// choix de style de flche
  	JToolBar barStyleFleche1 = new JToolBar(JToolBar.HORIZONTAL);
  	JToolBar barStyleFleche2 = new JToolBar(JToolBar.HORIZONTAL);
  	// Des boutons servant  dterminer le style des flches cres (vecteurs et
  	// marques d'angle orientes)
		MtgStyleFlecheButton buttonStyleFlecheLonguePleine = new MtgStyleFlecheButton(frame, StyleFleche.FlecheLonguePleine);
		MtgStyleFlecheButton buttonStyleFlecheCourtePleine = new MtgStyleFlecheButton(frame, StyleFleche.FlecheCourtePleine);
		MtgStyleFlecheButton buttonStyleFlecheLongueSimple = new MtgStyleFlecheButton(frame, StyleFleche.FlecheLongueSimple);
		MtgStyleFlecheButton buttonStyleFlecheCourteSimple = new MtgStyleFlecheButton(frame, StyleFleche.FlecheCourteSimple);
  	// Un groupe de boutons pour englober tous les boutons de la barre d'outil de
  	// choix de style de point
  	ButtonGroup btngroupStyleFleche = new ButtonGroup();
		barStyleFleche1.setMargin(ins);
		barStyleFleche2.setMargin(ins);
		barStyleFleche1.setFloatable(false);
		barStyleFleche2.setFloatable(false);
		btngroupStyleFleche.add(buttonStyleFlecheLonguePleine);
		btngroupStyleFleche.add(buttonStyleFlecheCourtePleine);
		btngroupStyleFleche.add(buttonStyleFlecheLongueSimple);
		btngroupStyleFleche.add(buttonStyleFlecheCourteSimple);
		// On active le petit rond par dfaut comme style de point
		buttonStyleFlecheLonguePleine.setSelected(true);
		barStyleFleche1.add(buttonStyleFlecheLonguePleine);
		barStyleFleche1.add(buttonStyleFlecheCourtePleine);
		barStyleFleche2.add(buttonStyleFlecheLongueSimple);
		barStyleFleche2.add(buttonStyleFlecheCourteSimple);
		barStyleFleche1.setBorder(BorderFactory.createEmptyBorder(0, 2, 0, 2));
		barStyleFleche2.setBorder(BorderFactory.createEmptyBorder(0, 2, 0, 2));
		setBorder(BorderFactory.createEtchedBorder());
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		add(barStyleFleche1);
		add(barStyleFleche2);	
  }

	public void mouseClicked(MouseEvent arg0) {
	}  
	public void mouseEntered(MouseEvent arg0) {
    if (getCursor() != MtgFrame.defaultCursor) frame.setCursor(MtgFrame.defaultCursor);
	}
	public void mouseExited(MouseEvent arg0) {
	}
	public void mousePressed(MouseEvent arg0) {
	}
	public void mouseReleased(MouseEvent arg0) {
	}  
  
}
