/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CListeObjets;
import objets.CSolutionEquation;
import objets.CValeurAssocieeAVariable;
import dialogs.SolutionEquationDlg;

public class OutilSolutionEquation extends Outil {
  public OutilSolutionEquation(MtgFrame frameInit) {
    super(frameInit, false);
  }
  
  @Override
  public void select() {
    super.select();
    MtgInternalFrame cadre = frame.cadreActif();
    CListeObjets liste = cadre.listePr;
    CValeurAssocieeAVariable vala = new CValeurAssocieeAVariable(liste, 0);
    CValeurAssocieeAVariable valb = new CValeurAssocieeAVariable(liste, 0);
    CValeurAssocieeAVariable vale = new CValeurAssocieeAVariable(liste, 0);
    CSolutionEquation sol = new CSolutionEquation(liste, null, false, "", vala, valb, vale);    
    SolutionEquationDlg dlg = new SolutionEquationDlg(frame, sol, false);
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(sol))
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil79"));    	
    }
    frame.activeOutilCapture();
  }  
}
